<?

###############################################################

function InstallationAborted ()
{
  global $TMP_FOLDER;

  print "  .\n";
  DeleteFilesInDirectory ($TMP_FOLDER);
  exit;
}

###############################################################

function UninstallationAborted ()
{
  global $TMP_FOLDER;

  print "  .\n";
  DeleteFilesInDirectory ($TMP_FOLDER);
  exit;
}

###############################################################

function LoadID ()
{
 global $TMP_FOLDER;
 global $Keyword, $SystemVersion, $SystemID, $Patch, $Name;
 global $ExampleURL, $HelpURL, $Description, $Parameters;


 $FileID = "id.txt";
 $fp = fopen ($TMP_FOLDER.$FileID, "r");
 $Keyword = chop (fgets($fp, 4096));
 $SystemID = chop (fgets($fp, 4096));
 $SystemVersion = chop (fgets($fp, 4096));
 $Patches = chop (fgets($fp, 4096));

 $tok = strtok($Patches," ");
 while ($tok) {
     $Patch [] = $tok;
     $tok = strtok(" ");

 }

 $Name = chop (fgets($fp, 4096));
 $ExampleURL = chop (fgets($fp, 4096));
 $HelpURL = chop (fgets($fp, 4096));
 $Description = chop (fgets($fp, 4096));

 fclose ($fp);


 $FileParam = "parameters.txt";
 $fp = fopen ($TMP_FOLDER.$FileParam, "r");
 while (!feof ($fp)) {
   $Parameters .= fgets($fp, 4096);
 }
 fclose ($fp);

}

###############################################################

function CopyFiles ()
{
 global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $DOCUMENT_ROOT;
 global $Keyword;

 $FileWithFileList = "files.txt";
 $COPY_FOLDER = $DOCUMENT_ROOT;

 mkdir ($MODULE_FOLDER.$Keyword, 0775);

 copy ($TMP_FOLDER."index.php", $MODULE_FOLDER.$Keyword."/index.php");
 copy ($TMP_FOLDER."function.inc.php", $MODULE_FOLDER.$Keyword."/function.inc.php");

 if (is_readable($TMP_FOLDER."admin.php")) copy ($TMP_FOLDER."admin.php", $MODULE_FOLDER.$Keyword."/admin.php");
 if (is_readable($TMP_FOLDER."admin.inc.php")) copy ($TMP_FOLDER."admin.inc.php", $MODULE_FOLDER.$Keyword."/admin.inc.php");
 if (is_readable($TMP_FOLDER."setup.php")) copy ($TMP_FOLDER."setup.php", $MODULE_FOLDER.$Keyword."/setup.php");

 $fpAny = fopen ($TMP_FOLDER.$FileWithFileList, "r");

 while (!feof ($fpAny)) {
   $file_name = chop (fgets($fpAny, 4096));
   if (strlen($file_name) == 0) break;
   $directory = dirname ($file_name);

   $tmpDirectory = $COPY_FOLDER;
   $tok = strtok($directory,"/");
   while ($tok) {
     $tmpDirectory .= "/".$tok;
     @mkdir ($tmpDirectory, 0775);
     $tok = strtok("/");
   }

   @copy ($TMP_FOLDER.$file_name, $COPY_FOLDER."/".$file_name);

 }

 fclose ($fpAny);

}

###############################################################

function CheckFiles ()
{
 global $TMP_FOLDER;

 if (!is_readable ($TMP_FOLDER."id.txt") ) {
    print "   id.txt.\n";
    InstallationAborted ();
 }

 if (!is_readable ($TMP_FOLDER."sql.txt") ) {
    print "   sql.txt.\n";
    InstallationAborted ();
 }

 if (!is_readable ($TMP_FOLDER."files.txt") ) {
    print "   files.txt.\n";
    InstallationAborted ();
 }

 if (!is_readable ($TMP_FOLDER."parameters.txt") ) {
    print "   parameters.txt.\n";
    InstallationAborted ();
 }

 if (!is_readable ($TMP_FOLDER."index.php") ) {
    print "   index.php.\n";
    InstallationAborted ();
 }

 if (!is_readable ($TMP_FOLDER."install.php") ) {
    print "   install.php.\n";
    InstallationAborted ();
 }

 if (!is_readable ($TMP_FOLDER."message.txt") ) {
    print "   message.txt.\n";
    InstallationAborted ();
 }

 if (!is_readable ($TMP_FOLDER."function.inc.php") ) {
    print "   function.inc.php.\n";
    InstallationAborted ();
 }


}

###############################################################

function CheckDeps ()
{
 global $TMP_FOLDER, $LinkID;
 global $Patch;

 $ReturnValue = 1;
 LoadID ();

 $select = "select * from Patch";
 $Result = mysql_query ($select, $LinkID);
 while ($Array[] = mysql_fetch_assoc($Result) ) {}

 while (list ($key, $val) = each ($Patch) ) {
     #echo "$key=$val<br>";
     $cmp = 0;
     for ($i=0; $i<count($Array); $i++) {
         if ( strcmp ($Array[$i]["Patch_Name"],$val) == 0 ) { $cmp++; break; }
     }
     if ($cmp == 0) {
        print "      ".$val.".\n";
        $ReturnValue = 0;
     }
 }

 return $ReturnValue;

}

###############################################################

function IsAlreadyInstalled ()
{
 global $TMP_FOLDER, $LinkID;
 global $Keyword;

 $select = "select Keyword from Module where Keyword='".$Keyword."'";
 $Result = mysql_query ($select, $LinkID);
 if ( mysql_num_rows($Result) > 0 ) return 1;
 return 0;
}

###############################################################

function ModuleUpdateCompleted ()
{
 global $LinkID;

 while (list($key, $val) = each($_POST)) {
       eval("\$".$key."='".$val."';");
 }

 $update  = "update Module set ";
 $update .= "Subdivision_ID='".$SubdivisionID."',";
 $update .= "Parameters='".$Parameters."'";
 $update .= " where Module_ID=".$ModuleID;

 $Result = mysql_query ($update, $LinkID);

}

###############################################################

function TitleModule ()
{
 global $perm;

 if ( $perm->isSupervisor() || $perm->isGuest() ) AddModuleForm ();
 ModuleList ();
}

?>
