<?
require ("../../vars.inc.php");
require ("../function.inc.php");
require ("function.inc.php");
require ("subclass.inc.php");

$Delimeter = " &gt ";
$CatalogueURL = "/netcat/admin/catalogue/?phase=6&CatalogueID=";
$SubdivisionURL = "/netcat/admin/subdivision/?phase=4&SubdivisionID=";

$loc = new SubdivisionLocation ($CatalogueID, $ParentSubID, $SubdivisionID);
$sh = new SubdivisionHierarchy ($Delimeter, $CatalogueURL, $SubdivisionURL);

$main_section = "control";
$item_id = 1;
$Title1 = "<a href=/netcat/admin/catalogue/>".SECTION_CONTROL_CONTENT_CATALOGUE."</a>";
$Title1 .= $Delimeter.$sh->Link;

$Title2 = CONTROL_CONTENT_SUBDIVISION_SUBCLASS_CLASSLIST_SECTION;
$Title2_1 = CONTROL_CONTENT_SUBDIVISION_SUBCLASS_CLASSLIST_SITE;
$Title3 = "<a href=\"/netcat/admin/subdivision/SubClass.php?CatalogueID=".$CatalogueID."&SubdivisionID=".$SubdivisionID."\">".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_CLASSLIST_SECTION."</a>";
$Title4 = CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ADDCLASS;
$Title5 = GetSubClassName ($SubClassID);
$Title6 = CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ADDCLASS;
$Title7 = CONTROL_CONTENT_SUBDIVISION_SUBCLASS_OPTIONSCLASS;
$Title8 = CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ADDCLASSSITE;
$Title9 = "<a href=/netcat/admin/subdivision/SubClass.php?CatalogueID=".$CatalogueID.">".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_CLASSLIST_SITE."</a>";


if (isset($phase)) {

   switch ($phase) {
      case 1:
        #   
        if (!$SubdivisionID) BeginHtml ($Title8, $Title1.$Delimeter.$Title9.$Delimeter.$Title8, "http://".$DOC_DOMAIN."/management/sites/sections/class/add/");
        else BeginHtml ($Title6, $Title1.$Delimeter.$Title3.$Delimeter.$Title4, "http://".$DOC_DOMAIN."/management/sites/sections/class/add/");
        ActionForm (0, 2, 1);

       break;

      case 2:
        #   

        if (!($perm->isSupervisor () || $perm->isManager() || $perm->isGuest() || $perm->isCatalogueAdmin (GetCatalogueBySubdivision($SubdivisionID)) || $perm->isSubdivisionAdmin ($SubdivisionID) ) ) {
           BeginHtml ($Title2, $Title1.$Delimeter.$Title3.$Delimeter.$Title4, "");
           print $NO_RIGHTS_MESSAGE;
           EndHTML ();
           exit;
        }

        BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/management/sites/sections/class/");

        if ( $perm->isGuest() ) {
           print $NO_RIGHTS_MESSAGE;
           ShowList ();
           break;
        }


        if ($SubClassName == "") {
           print "<b>".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_NAME."</b>";
           ActionForm (0, 2, 1);
           break;
        }

         if ( strspn(strtolower($EnglishName), "abcdefghijklmnopqrstuvwxyz0123456789-") != strlen($EnglishName) ) {
            print "<b>".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_KEYWORD_INVALID."</b>";
            ActionForm (0, 2, 1);
            break;
         }

        if ( ( !IsAllowedSubClassEnglishName ($EnglishName, $SubdivisionID, 0) ) || ( $EnglishName == "" ) ) {
           print "<b>".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_KEYWORD."</b>";
           ActionForm (0, 2, 1);
           break;
        }

        ActionSubClassCompleted (1);
        ShowList ();

      break;

        case 3:
         #   
         BeginHtml ($Title7, $Title1.$Delimeter.$Title3.$Delimeter.$Title5, "http://".$DOC_DOMAIN."/management/sites/sections/class/settings/");
         ActionForm ($SubClassID, 4, 2);

         break;

        case 4:
         #   

         if (!($perm->isSupervisor () || $perm->isManager() || $perm->isGuest() || $perm->isCatalogueAdmin (GetCatalogueBySubdivision($SubdivisionID)) || $perm->isSubdivisionAdmin ($SubdivisionID) || $perm->isSubClassAdmin ($SubClassID)) ) {
            BeginHtml ($Title2, $Title1.$Delimeter.$Title3.$Delimeter.$Title4, "");
            print $NO_RIGHTS_MESSAGE;
            EndHTML ();
            exit;
         }

         BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/management/sites/sections/class/");

         if ( $perm->isGuest() ) {
            print $NO_RIGHTS_MESSAGE;
            ShowList ();
            break;
         }

         if ($SubClassName == "") {
            print "<b>".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_NAME."</b>";
            ActionForm ($SubClassID, 4, 2);
            break;
         }

         if ( strspn(strtolower($EnglishName), "abcdefghijklmnopqrstuvwxyz0123456789-") != strlen($EnglishName) ) {
            print "<b>".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_KEYWORD_INVALID."</b>";
            ActionForm ($SubClassID, 4, 2);
            break;
         }

         if ( ( !IsAllowedSubClassEnglishName ($EnglishName, $SubdivisionID, $SubClassID) ) || ( $EnglishName == "" ) ) {
            print "<b>".CONTROL_CONTENT_SUBDIVISION_SUBCLASS_ERROR_KEYWORD."</b>";
            ActionForm ($SubClassID, 4, 2);
            break;
         }

         if ( ActionSubClassCompleted (2) ) {
            ShowList ();
         } else {
            ActionForm ($SubClassID, 4, 2);
         }

         break;

        case 5:
         #  

         if (!($perm->isSupervisor () || $perm->isManager() || $perm->isGuest() || $perm->isCatalogueAdmin (GetCatalogueBySubdivision($SubdivisionID)) || $perm->isSubdivisionAdmin ($SubdivisionID) ) ) {
            BeginHtml ($Title2, $Title1.$Delimeter.$Title3.$Delimeter.$Title4, "");
            print $NO_RIGHTS_MESSAGE;
            EndHTML ();
            exit;
         }

         BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/management/sites/sections/class/");

         if ( $perm->isGuest() ) {
            print $NO_RIGHTS_MESSAGE;
            ShowList ();
            break;
         }

         UpdateSubClassPriority();

         reset($_POST);
         while (list($key, $val) = each($_POST)) {
                
           if (strcmp (substr($key,0,strlen("Delete") ), "Delete") == 0) {
              $DeleteMessage = "delete from Message".GetClassIDBySubClass($val)." where Subdivision_ID=".$SubdivisionID." and Sub_Class_ID=".$val;
              $DeleteSubscriber = "delete from Subscriber WHERE Sub_Class_ID=".$val;
              mysql_query ($DeleteMessage);

              DeleteSubClass ($val);
           }

         }

         reset($_GET);
         while (list($key, $val) = each($_GET)) {
                
           if (strcmp (substr($key,0,strlen("Delete") ), "Delete") == 0) {
              $DeleteMessage = "delete from Message".GetClassIDBySubClass($val);
              $DeleteMessage .= " where Subdivision_ID=".$SubdivisionID;
              $DeleteMessage .= " and Sub_Class_ID=".$val;
                if (GetSystemTableByID($val))
                      mysql_query ($DeleteMessage);

              DeleteSubClass ($val);
           }

         }

         ShowList ();

         break;

         case 6:

         #       
         BeginHtml ($Title5, $Title1.(($loc->SubdivisionID)?$Delimeter.$Title3.$Delimeter.$Title5:$Delimeter.$Title9.$Delimeter.$Title5), "http://".$DOC_DOMAIN."/management/sites/sections/class/settings/");
         ShowSubClassMenu ($SubClassID, 9, "index.php", 3, "SubClass.php", 12, "index.php");

         break;



   }


} else {
  if (!$SubdivisionID) BeginHtml ($Title2_1, $Title1.$Delimeter.$Title2_1, "http://".$DOC_DOMAIN."/management/sites/sections/class/");
  else BeginHtml ($Title2, $Title1.$Delimeter.$Title2, "http://".$DOC_DOMAIN."/management/sites/sections/class/");
  ShowList ();

}


EndHTML ();
?>
